
package no.usit.fsws.schemas.studinfo;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import no.uis.fsws.studinfo.data.Extensible;
import no.uis.fsws.studinfo.data.FsEksamensdato;
import no.uis.fsws.studinfo.data.FsVarighet;
import no.uis.fsws.studinfo.util.FsEksamensdatoAdapter;
import no.uis.fsws.studinfo.util.FsVarighetAdapter;


/**
 * <p>Java class for Eksamensdel complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="Eksamensdel">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="eksamensdelnr" type="{http://www.w3.org/2001/XMLSchema}integer"/>
 *         &lt;element name="eksamensdelnavn" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="studiepoeng-reduksjon" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="varighet" type="{http://fsws.usit.no/schemas/studinfo}VarighetEmne"/>
 *         &lt;element name="eksamensform" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="karaktervekt" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="karregel" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="eksamensdag-liste">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                 &lt;sequence>
 *                   &lt;element name="eksamensdag" type="{http://fsws.usit.no/schemas/studinfo}Eksamensdag" maxOccurs="unbounded" minOccurs="0"/>
 *                 &lt;/sequence>
 *               &lt;/restriction>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *         &lt;element name="dato-eksamen" type="{http://fsws.usit.no/schemas/studinfo}FsEksamensdato"/>
 *         &lt;element name="lovlig-hjelpemiddel-liste">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                 &lt;sequence>
 *                   &lt;element name="lovlig-hjelpemiddel" type="{http://www.w3.org/2001/XMLSchema}string" maxOccurs="unbounded" minOccurs="0"/>
 *                 &lt;/sequence>
 *               &lt;/restriction>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *         &lt;any maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Eksamensdel", propOrder = {
    "eksamensdelnr",
    "eksamensdelnavn",
    "studiepoengReduksjon",
    "varighet",
    "eksamensform",
    "karaktervekt",
    "karregel",
    "eksamensdagListe",
    "datoEksamen",
    "lovligHjelpemiddelListe",
    "any"
})
public class Eksamensdel
    extends Extensible
    implements Serializable
{

    private final static long serialVersionUID = 1L;
    @XmlElement(required = true)
    protected BigInteger eksamensdelnr;
    @XmlElement(required = true)
    protected String eksamensdelnavn;
    @XmlElement(name = "studiepoeng-reduksjon", required = true, nillable = true)
    protected String studiepoengReduksjon;
    @XmlElement(required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsVarighetAdapter.class)
    protected FsVarighet varighet;
    @XmlElement(required = true, nillable = true)
    protected String eksamensform;
    @XmlElement(required = true, nillable = true)
    protected String karaktervekt;
    @XmlElement(required = true, nillable = true)
    protected String karregel;
    @XmlElement(name = "eksamensdag-liste", required = true, nillable = true)
    protected EksamensdagListe eksamensdagListe;
    @XmlElement(name = "dato-eksamen", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsEksamensdatoAdapter.class)
    protected FsEksamensdato datoEksamen;
    @XmlElement(name = "lovlig-hjelpemiddel-liste", required = true, nillable = true)
    protected LovligHjelpemiddelListe lovligHjelpemiddelListe;
    @XmlAnyElement(lax = true)
    protected List<Object> any;

    /**
     * Gets the value of the eksamensdelnr property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getEksamensdelnr() {
        return eksamensdelnr;
    }

    /**
     * Sets the value of the eksamensdelnr property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setEksamensdelnr(BigInteger value) {
        this.eksamensdelnr = value;
    }

    public boolean isSetEksamensdelnr() {
        return (this.eksamensdelnr!= null);
    }

    /**
     * Gets the value of the eksamensdelnavn property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getEksamensdelnavn() {
        return eksamensdelnavn;
    }

    /**
     * Sets the value of the eksamensdelnavn property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setEksamensdelnavn(String value) {
        this.eksamensdelnavn = value;
    }

    public boolean isSetEksamensdelnavn() {
        return (this.eksamensdelnavn!= null);
    }

    /**
     * Gets the value of the studiepoengReduksjon property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudiepoengReduksjon() {
        return studiepoengReduksjon;
    }

    /**
     * Sets the value of the studiepoengReduksjon property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudiepoengReduksjon(String value) {
        this.studiepoengReduksjon = value;
    }

    public boolean isSetStudiepoengReduksjon() {
        return (this.studiepoengReduksjon!= null);
    }

    /**
     * Gets the value of the varighet property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsVarighet getVarighet() {
        return varighet;
    }

    /**
     * Sets the value of the varighet property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVarighet(FsVarighet value) {
        this.varighet = value;
    }

    public boolean isSetVarighet() {
        return (this.varighet!= null);
    }

    /**
     * Gets the value of the eksamensform property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getEksamensform() {
        return eksamensform;
    }

    /**
     * Sets the value of the eksamensform property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setEksamensform(String value) {
        this.eksamensform = value;
    }

    public boolean isSetEksamensform() {
        return (this.eksamensform!= null);
    }

    /**
     * Gets the value of the karaktervekt property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getKaraktervekt() {
        return karaktervekt;
    }

    /**
     * Sets the value of the karaktervekt property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKaraktervekt(String value) {
        this.karaktervekt = value;
    }

    public boolean isSetKaraktervekt() {
        return (this.karaktervekt!= null);
    }

    /**
     * Gets the value of the karregel property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getKarregel() {
        return karregel;
    }

    /**
     * Sets the value of the karregel property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKarregel(String value) {
        this.karregel = value;
    }

    public boolean isSetKarregel() {
        return (this.karregel!= null);
    }

    /**
     * Gets the value of the eksamensdagListe property.
     * 
     * @return
     *     possible object is
     *     {@link EksamensdagListe }
     *     
     */
    public EksamensdagListe getEksamensdagListe() {
        return eksamensdagListe;
    }

    /**
     * Sets the value of the eksamensdagListe property.
     * 
     * @param value
     *     allowed object is
     *     {@link EksamensdagListe }
     *     
     */
    public void setEksamensdagListe(EksamensdagListe value) {
        this.eksamensdagListe = value;
    }

    public boolean isSetEksamensdagListe() {
        return (this.eksamensdagListe!= null);
    }

    /**
     * Gets the value of the datoEksamen property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsEksamensdato getDatoEksamen() {
        return datoEksamen;
    }

    /**
     * Sets the value of the datoEksamen property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDatoEksamen(FsEksamensdato value) {
        this.datoEksamen = value;
    }

    public boolean isSetDatoEksamen() {
        return (this.datoEksamen!= null);
    }

    /**
     * Gets the value of the lovligHjelpemiddelListe property.
     * 
     * @return
     *     possible object is
     *     {@link LovligHjelpemiddelListe }
     *     
     */
    public LovligHjelpemiddelListe getLovligHjelpemiddelListe() {
        return lovligHjelpemiddelListe;
    }

    /**
     * Sets the value of the lovligHjelpemiddelListe property.
     * 
     * @param value
     *     allowed object is
     *     {@link LovligHjelpemiddelListe }
     *     
     */
    public void setLovligHjelpemiddelListe(LovligHjelpemiddelListe value) {
        this.lovligHjelpemiddelListe = value;
    }

    public boolean isSetLovligHjelpemiddelListe() {
        return (this.lovligHjelpemiddelListe!= null);
    }

    /**
     * Gets the value of the any property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the any property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAny().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Object }
     * 
     * 
     */
    public List<Object> getAny() {
        if (any == null) {
            any = new ArrayList<Object>();
        }
        return this.any;
    }

    public boolean isSetAny() {
        return ((this.any!= null)&&(!this.any.isEmpty()));
    }

    public void unsetAny() {
        this.any = null;
    }

}
