
package no.usit.fsws.schemas.studinfo;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import no.uis.fsws.studinfo.data.FsVarighet;
import no.uis.fsws.studinfo.data.FsYearSemester;
import no.uis.fsws.studinfo.util.FsVarighetAdapter;
import no.uis.fsws.studinfo.util.FsYearSemesterAdapter;
import no.uis.fsws.studinfo.util.YesNoTypeAdapter;


/**
 * <p>Java class for Studieprogram complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="Studieprogram">
 *   &lt;complexContent>
 *     &lt;extension base="{http://fsws.usit.no/schemas/studinfo}FsType">
 *       &lt;sequence>
 *         &lt;element name="studieprogramkode" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="studieprogramnavn" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="studieprogramnavn_vitn" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="studieprogramnavn_en" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="studieprogramnavn_vitn_en" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="studiepoeng" type="{http://www.w3.org/2001/XMLSchema}integer"/>
 *         &lt;element name="studieniva" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="studienivakode" type="{http://www.w3.org/2001/XMLSchema}integer"/>
 *         &lt;element name="studienivanavn" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="fagansvarlig" type="{http://fsws.usit.no/schemas/studinfo}Sted"/>
 *         &lt;element name="adminansvarlig" type="{http://fsws.usit.no/schemas/studinfo}Sted"/>
 *         &lt;element name="gradnavn" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="nuskode" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="url" type="{http://www.w3.org/2001/XMLSchema}anyURI"/>
 *         &lt;element name="finansieringsprosent" type="{http://www.w3.org/2001/XMLSchema}integer"/>
 *         &lt;element name="heltidsprosent" type="{http://www.w3.org/2001/XMLSchema}integer"/>
 *         &lt;element name="varighet" type="{http://fsws.usit.no/schemas/studinfo}VarighetProgram"/>
 *         &lt;element name="grunnstudium" type="{http://fsws.usit.no/schemas/studinfo}YESNOType"/>
 *         &lt;element name="kulltrinnplan" type="{http://fsws.usit.no/schemas/studinfo}YESNOType"/>
 *         &lt;element name="arbeidsformer" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="fagplan_tekst" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="fagplan_URL" type="{http://www.w3.org/2001/XMLSchema}anyURI"/>
 *         &lt;element name="innhold" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="intro" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="kontaktinformasjon" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="kvalifik_og_jobbmuligheter" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="laringsutbytte" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="litteratur" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="opptaksinformasjon" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="opptakskrav" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="p-formkrav" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="p-innhold" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="p-kortintr" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="p-profkval" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="p-studkval" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="se-introd" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="rammeplan_tekst" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="rammeplan_URL" type="{http://www.w3.org/2001/XMLSchema}anyURI"/>
 *         &lt;element name="studentevaluering" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="utenlandsopphold" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="vurdering_tilleggstekst" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="opptak-liste">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                 &lt;sequence>
 *                   &lt;element name="opptak" type="{http://fsws.usit.no/schemas/studinfo}Opptak" maxOccurs="unbounded" minOccurs="0"/>
 *                 &lt;/sequence>
 *               &lt;/restriction>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *         &lt;element name="fagkode" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="sprak-liste" type="{http://fsws.usit.no/schemas/studinfo}SprakListe"/>
 *         &lt;element name="utdanningsplan" type="{http://fsws.usit.no/schemas/studinfo}Utdanningsplan"/>
 *         &lt;element name="planforslag" type="{http://fsws.usit.no/schemas/studinfo}Planforslag"/>
 *         &lt;element name="termin-siste-opptak" type="{http://fsws.usit.no/schemas/studinfo}FsYearSemester"/>
 *         &lt;any maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Studieprogram", propOrder = {
    "studieprogramkode",
    "studieprogramnavn",
    "studieprogramnavnVitn",
    "studieprogramnavnEn",
    "studieprogramnavnVitnEn",
    "studiepoeng",
    "studieniva",
    "studienivakode",
    "studienivanavn",
    "fagansvarlig",
    "adminansvarlig",
    "gradnavn",
    "nuskode",
    "url",
    "finansieringsprosent",
    "heltidsprosent",
    "varighet",
    "grunnstudium",
    "kulltrinnplan",
    "arbeidsformer",
    "fagplanTekst",
    "fagplanURL",
    "innhold",
    "intro",
    "kontaktinformasjon",
    "kvalifikOgJobbmuligheter",
    "laringsutbytte",
    "litteratur",
    "opptaksinformasjon",
    "opptakskrav",
    "pFormkrav",
    "pInnhold",
    "pKortintr",
    "pProfkval",
    "pStudkval",
    "seIntrod",
    "rammeplanTekst",
    "rammeplanURL",
    "studentevaluering",
    "utenlandsopphold",
    "vurderingTilleggstekst",
    "opptakListe",
    "fagkode",
    "sprakListe",
    "utdanningsplan",
    "planforslag",
    "terminSisteOpptak",
    "any"
})
public class Studieprogram
    extends FsType
    implements Serializable
{

    private final static long serialVersionUID = 1L;
    @XmlElement(required = true)
    protected String studieprogramkode;
    @XmlElement(required = true)
    protected String studieprogramnavn;
    @XmlElement(name = "studieprogramnavn_vitn", required = true, nillable = true)
    protected String studieprogramnavnVitn;
    @XmlElement(name = "studieprogramnavn_en", required = true, nillable = true)
    protected String studieprogramnavnEn;
    @XmlElement(name = "studieprogramnavn_vitn_en", required = true, nillable = true)
    protected String studieprogramnavnVitnEn;
    @XmlElement(required = true)
    protected BigInteger studiepoeng;
    @XmlElement(required = true)
    protected String studieniva;
    @XmlElement(required = true)
    protected BigInteger studienivakode;
    @XmlElement(required = true)
    protected String studienivanavn;
    @XmlElement(required = true, nillable = true)
    protected Sted fagansvarlig;
    @XmlElement(required = true, nillable = true)
    protected Sted adminansvarlig;
    @XmlElement(required = true, nillable = true)
    protected String gradnavn;
    @XmlElement(required = true)
    protected String nuskode;
    @XmlElement(required = true, nillable = true)
    @XmlSchemaType(name = "anyURI")
    protected String url;
    @XmlElement(required = true, nillable = true)
    protected BigInteger finansieringsprosent;
    @XmlElement(required = true, nillable = true)
    protected BigInteger heltidsprosent;
    @XmlElement(required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsVarighetAdapter.class)
    protected FsVarighet varighet;
    @XmlElement(required = true, type = String.class, defaultValue = "N")
    @XmlJavaTypeAdapter(YesNoTypeAdapter.class)
    protected Boolean grunnstudium;
    @XmlElement(required = true, type = String.class, defaultValue = "N")
    @XmlJavaTypeAdapter(YesNoTypeAdapter.class)
    protected Boolean kulltrinnplan;
    @XmlElement(required = true, nillable = true)
    protected String arbeidsformer;
    @XmlElement(name = "fagplan_tekst", required = true, nillable = true)
    protected String fagplanTekst;
    @XmlElement(name = "fagplan_URL", required = true, nillable = true)
    @XmlSchemaType(name = "anyURI")
    protected String fagplanURL;
    @XmlElement(required = true, nillable = true)
    protected String innhold;
    @XmlElement(required = true, nillable = true)
    protected String intro;
    @XmlElement(required = true, nillable = true)
    protected String kontaktinformasjon;
    @XmlElement(name = "kvalifik_og_jobbmuligheter", required = true, nillable = true)
    protected String kvalifikOgJobbmuligheter;
    @XmlElement(required = true, nillable = true)
    protected String laringsutbytte;
    @XmlElement(required = true, nillable = true)
    protected String litteratur;
    @XmlElement(required = true, nillable = true)
    protected String opptaksinformasjon;
    @XmlElement(required = true, nillable = true)
    protected String opptakskrav;
    @XmlElement(name = "p-formkrav", required = true, nillable = true)
    protected String pFormkrav;
    @XmlElement(name = "p-innhold", required = true, nillable = true)
    protected String pInnhold;
    @XmlElement(name = "p-kortintr", required = true, nillable = true)
    protected String pKortintr;
    @XmlElement(name = "p-profkval", required = true, nillable = true)
    protected String pProfkval;
    @XmlElement(name = "p-studkval", required = true, nillable = true)
    protected String pStudkval;
    @XmlElement(name = "se-introd", required = true, nillable = true)
    protected String seIntrod;
    @XmlElement(name = "rammeplan_tekst", required = true, nillable = true)
    protected String rammeplanTekst;
    @XmlElement(name = "rammeplan_URL", required = true, nillable = true)
    @XmlSchemaType(name = "anyURI")
    protected String rammeplanURL;
    @XmlElement(required = true, nillable = true)
    protected String studentevaluering;
    @XmlElement(required = true, nillable = true)
    protected String utenlandsopphold;
    @XmlElement(name = "vurdering_tilleggstekst", required = true, nillable = true)
    protected String vurderingTilleggstekst;
    @XmlElement(name = "opptak-liste", required = true, nillable = true)
    protected OpptakListe opptakListe;
    @XmlElement(required = true, nillable = true)
    protected String fagkode;
    @XmlElement(name = "sprak-liste", required = true, nillable = true)
    protected SprakListe sprakListe;
    @XmlElement(required = true, nillable = true)
    protected Utdanningsplan utdanningsplan;
    @XmlElement(required = true, nillable = true)
    protected Planforslag planforslag;
    @XmlElement(name = "termin-siste-opptak", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsYearSemesterAdapter.class)
    protected FsYearSemester terminSisteOpptak;
    @XmlAnyElement(lax = true)
    protected List<Object> any;

    /**
     * Gets the value of the studieprogramkode property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudieprogramkode() {
        return studieprogramkode;
    }

    /**
     * Sets the value of the studieprogramkode property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudieprogramkode(String value) {
        this.studieprogramkode = value;
    }

    public boolean isSetStudieprogramkode() {
        return (this.studieprogramkode!= null);
    }

    /**
     * Gets the value of the studieprogramnavn property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudieprogramnavn() {
        return studieprogramnavn;
    }

    /**
     * Sets the value of the studieprogramnavn property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudieprogramnavn(String value) {
        this.studieprogramnavn = value;
    }

    public boolean isSetStudieprogramnavn() {
        return (this.studieprogramnavn!= null);
    }

    /**
     * Gets the value of the studieprogramnavnVitn property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudieprogramnavnVitn() {
        return studieprogramnavnVitn;
    }

    /**
     * Sets the value of the studieprogramnavnVitn property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudieprogramnavnVitn(String value) {
        this.studieprogramnavnVitn = value;
    }

    public boolean isSetStudieprogramnavnVitn() {
        return (this.studieprogramnavnVitn!= null);
    }

    /**
     * Gets the value of the studieprogramnavnEn property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudieprogramnavnEn() {
        return studieprogramnavnEn;
    }

    /**
     * Sets the value of the studieprogramnavnEn property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudieprogramnavnEn(String value) {
        this.studieprogramnavnEn = value;
    }

    public boolean isSetStudieprogramnavnEn() {
        return (this.studieprogramnavnEn!= null);
    }

    /**
     * Gets the value of the studieprogramnavnVitnEn property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudieprogramnavnVitnEn() {
        return studieprogramnavnVitnEn;
    }

    /**
     * Sets the value of the studieprogramnavnVitnEn property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudieprogramnavnVitnEn(String value) {
        this.studieprogramnavnVitnEn = value;
    }

    public boolean isSetStudieprogramnavnVitnEn() {
        return (this.studieprogramnavnVitnEn!= null);
    }

    /**
     * Gets the value of the studiepoeng property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getStudiepoeng() {
        return studiepoeng;
    }

    /**
     * Sets the value of the studiepoeng property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setStudiepoeng(BigInteger value) {
        this.studiepoeng = value;
    }

    public boolean isSetStudiepoeng() {
        return (this.studiepoeng!= null);
    }

    /**
     * Gets the value of the studieniva property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudieniva() {
        return studieniva;
    }

    /**
     * Sets the value of the studieniva property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudieniva(String value) {
        this.studieniva = value;
    }

    public boolean isSetStudieniva() {
        return (this.studieniva!= null);
    }

    /**
     * Gets the value of the studienivakode property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getStudienivakode() {
        return studienivakode;
    }

    /**
     * Sets the value of the studienivakode property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setStudienivakode(BigInteger value) {
        this.studienivakode = value;
    }

    public boolean isSetStudienivakode() {
        return (this.studienivakode!= null);
    }

    /**
     * Gets the value of the studienivanavn property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudienivanavn() {
        return studienivanavn;
    }

    /**
     * Sets the value of the studienivanavn property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudienivanavn(String value) {
        this.studienivanavn = value;
    }

    public boolean isSetStudienivanavn() {
        return (this.studienivanavn!= null);
    }

    /**
     * Gets the value of the fagansvarlig property.
     * 
     * @return
     *     possible object is
     *     {@link Sted }
     *     
     */
    public Sted getFagansvarlig() {
        return fagansvarlig;
    }

    /**
     * Sets the value of the fagansvarlig property.
     * 
     * @param value
     *     allowed object is
     *     {@link Sted }
     *     
     */
    public void setFagansvarlig(Sted value) {
        this.fagansvarlig = value;
    }

    public boolean isSetFagansvarlig() {
        return (this.fagansvarlig!= null);
    }

    /**
     * Gets the value of the adminansvarlig property.
     * 
     * @return
     *     possible object is
     *     {@link Sted }
     *     
     */
    public Sted getAdminansvarlig() {
        return adminansvarlig;
    }

    /**
     * Sets the value of the adminansvarlig property.
     * 
     * @param value
     *     allowed object is
     *     {@link Sted }
     *     
     */
    public void setAdminansvarlig(Sted value) {
        this.adminansvarlig = value;
    }

    public boolean isSetAdminansvarlig() {
        return (this.adminansvarlig!= null);
    }

    /**
     * Gets the value of the gradnavn property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getGradnavn() {
        return gradnavn;
    }

    /**
     * Sets the value of the gradnavn property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setGradnavn(String value) {
        this.gradnavn = value;
    }

    public boolean isSetGradnavn() {
        return (this.gradnavn!= null);
    }

    /**
     * Gets the value of the nuskode property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNuskode() {
        return nuskode;
    }

    /**
     * Sets the value of the nuskode property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNuskode(String value) {
        this.nuskode = value;
    }

    public boolean isSetNuskode() {
        return (this.nuskode!= null);
    }

    /**
     * Gets the value of the url property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getUrl() {
        return url;
    }

    /**
     * Sets the value of the url property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setUrl(String value) {
        this.url = value;
    }

    public boolean isSetUrl() {
        return (this.url!= null);
    }

    /**
     * Gets the value of the finansieringsprosent property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getFinansieringsprosent() {
        return finansieringsprosent;
    }

    /**
     * Sets the value of the finansieringsprosent property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setFinansieringsprosent(BigInteger value) {
        this.finansieringsprosent = value;
    }

    public boolean isSetFinansieringsprosent() {
        return (this.finansieringsprosent!= null);
    }

    /**
     * Gets the value of the heltidsprosent property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getHeltidsprosent() {
        return heltidsprosent;
    }

    /**
     * Sets the value of the heltidsprosent property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setHeltidsprosent(BigInteger value) {
        this.heltidsprosent = value;
    }

    public boolean isSetHeltidsprosent() {
        return (this.heltidsprosent!= null);
    }

    /**
     * Gets the value of the varighet property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsVarighet getVarighet() {
        return varighet;
    }

    /**
     * Sets the value of the varighet property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVarighet(FsVarighet value) {
        this.varighet = value;
    }

    public boolean isSetVarighet() {
        return (this.varighet!= null);
    }

    /**
     * Gets the value of the grunnstudium property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public Boolean isGrunnstudium() {
        return grunnstudium;
    }

    /**
     * Sets the value of the grunnstudium property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setGrunnstudium(Boolean value) {
        this.grunnstudium = value;
    }

    public boolean isSetGrunnstudium() {
        return (this.grunnstudium!= null);
    }

    /**
     * Gets the value of the kulltrinnplan property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public Boolean isKulltrinnplan() {
        return kulltrinnplan;
    }

    /**
     * Sets the value of the kulltrinnplan property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKulltrinnplan(Boolean value) {
        this.kulltrinnplan = value;
    }

    public boolean isSetKulltrinnplan() {
        return (this.kulltrinnplan!= null);
    }

    /**
     * Gets the value of the arbeidsformer property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getArbeidsformer() {
        return arbeidsformer;
    }

    /**
     * Sets the value of the arbeidsformer property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setArbeidsformer(String value) {
        this.arbeidsformer = value;
    }

    public boolean isSetArbeidsformer() {
        return (this.arbeidsformer!= null);
    }

    /**
     * Gets the value of the fagplanTekst property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFagplanTekst() {
        return fagplanTekst;
    }

    /**
     * Sets the value of the fagplanTekst property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFagplanTekst(String value) {
        this.fagplanTekst = value;
    }

    public boolean isSetFagplanTekst() {
        return (this.fagplanTekst!= null);
    }

    /**
     * Gets the value of the fagplanURL property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFagplanURL() {
        return fagplanURL;
    }

    /**
     * Sets the value of the fagplanURL property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFagplanURL(String value) {
        this.fagplanURL = value;
    }

    public boolean isSetFagplanURL() {
        return (this.fagplanURL!= null);
    }

    /**
     * Gets the value of the innhold property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getInnhold() {
        return innhold;
    }

    /**
     * Sets the value of the innhold property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setInnhold(String value) {
        this.innhold = value;
    }

    public boolean isSetInnhold() {
        return (this.innhold!= null);
    }

    /**
     * Gets the value of the intro property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIntro() {
        return intro;
    }

    /**
     * Sets the value of the intro property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIntro(String value) {
        this.intro = value;
    }

    public boolean isSetIntro() {
        return (this.intro!= null);
    }

    /**
     * Gets the value of the kontaktinformasjon property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getKontaktinformasjon() {
        return kontaktinformasjon;
    }

    /**
     * Sets the value of the kontaktinformasjon property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKontaktinformasjon(String value) {
        this.kontaktinformasjon = value;
    }

    public boolean isSetKontaktinformasjon() {
        return (this.kontaktinformasjon!= null);
    }

    /**
     * Gets the value of the kvalifikOgJobbmuligheter property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getKvalifikOgJobbmuligheter() {
        return kvalifikOgJobbmuligheter;
    }

    /**
     * Sets the value of the kvalifikOgJobbmuligheter property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKvalifikOgJobbmuligheter(String value) {
        this.kvalifikOgJobbmuligheter = value;
    }

    public boolean isSetKvalifikOgJobbmuligheter() {
        return (this.kvalifikOgJobbmuligheter!= null);
    }

    /**
     * Gets the value of the laringsutbytte property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getLaringsutbytte() {
        return laringsutbytte;
    }

    /**
     * Sets the value of the laringsutbytte property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setLaringsutbytte(String value) {
        this.laringsutbytte = value;
    }

    public boolean isSetLaringsutbytte() {
        return (this.laringsutbytte!= null);
    }

    /**
     * Gets the value of the litteratur property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getLitteratur() {
        return litteratur;
    }

    /**
     * Sets the value of the litteratur property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setLitteratur(String value) {
        this.litteratur = value;
    }

    public boolean isSetLitteratur() {
        return (this.litteratur!= null);
    }

    /**
     * Gets the value of the opptaksinformasjon property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getOpptaksinformasjon() {
        return opptaksinformasjon;
    }

    /**
     * Sets the value of the opptaksinformasjon property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setOpptaksinformasjon(String value) {
        this.opptaksinformasjon = value;
    }

    public boolean isSetOpptaksinformasjon() {
        return (this.opptaksinformasjon!= null);
    }

    /**
     * Gets the value of the opptakskrav property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getOpptakskrav() {
        return opptakskrav;
    }

    /**
     * Sets the value of the opptakskrav property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setOpptakskrav(String value) {
        this.opptakskrav = value;
    }

    public boolean isSetOpptakskrav() {
        return (this.opptakskrav!= null);
    }

    /**
     * Gets the value of the pFormkrav property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPFormkrav() {
        return pFormkrav;
    }

    /**
     * Sets the value of the pFormkrav property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPFormkrav(String value) {
        this.pFormkrav = value;
    }

    public boolean isSetPFormkrav() {
        return (this.pFormkrav!= null);
    }

    /**
     * Gets the value of the pInnhold property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPInnhold() {
        return pInnhold;
    }

    /**
     * Sets the value of the pInnhold property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPInnhold(String value) {
        this.pInnhold = value;
    }

    public boolean isSetPInnhold() {
        return (this.pInnhold!= null);
    }

    /**
     * Gets the value of the pKortintr property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPKortintr() {
        return pKortintr;
    }

    /**
     * Sets the value of the pKortintr property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPKortintr(String value) {
        this.pKortintr = value;
    }

    public boolean isSetPKortintr() {
        return (this.pKortintr!= null);
    }

    /**
     * Gets the value of the pProfkval property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPProfkval() {
        return pProfkval;
    }

    /**
     * Sets the value of the pProfkval property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPProfkval(String value) {
        this.pProfkval = value;
    }

    public boolean isSetPProfkval() {
        return (this.pProfkval!= null);
    }

    /**
     * Gets the value of the pStudkval property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPStudkval() {
        return pStudkval;
    }

    /**
     * Sets the value of the pStudkval property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPStudkval(String value) {
        this.pStudkval = value;
    }

    public boolean isSetPStudkval() {
        return (this.pStudkval!= null);
    }

    /**
     * Gets the value of the seIntrod property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getSeIntrod() {
        return seIntrod;
    }

    /**
     * Sets the value of the seIntrod property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setSeIntrod(String value) {
        this.seIntrod = value;
    }

    public boolean isSetSeIntrod() {
        return (this.seIntrod!= null);
    }

    /**
     * Gets the value of the rammeplanTekst property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getRammeplanTekst() {
        return rammeplanTekst;
    }

    /**
     * Sets the value of the rammeplanTekst property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setRammeplanTekst(String value) {
        this.rammeplanTekst = value;
    }

    public boolean isSetRammeplanTekst() {
        return (this.rammeplanTekst!= null);
    }

    /**
     * Gets the value of the rammeplanURL property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getRammeplanURL() {
        return rammeplanURL;
    }

    /**
     * Sets the value of the rammeplanURL property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setRammeplanURL(String value) {
        this.rammeplanURL = value;
    }

    public boolean isSetRammeplanURL() {
        return (this.rammeplanURL!= null);
    }

    /**
     * Gets the value of the studentevaluering property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getStudentevaluering() {
        return studentevaluering;
    }

    /**
     * Sets the value of the studentevaluering property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setStudentevaluering(String value) {
        this.studentevaluering = value;
    }

    public boolean isSetStudentevaluering() {
        return (this.studentevaluering!= null);
    }

    /**
     * Gets the value of the utenlandsopphold property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getUtenlandsopphold() {
        return utenlandsopphold;
    }

    /**
     * Sets the value of the utenlandsopphold property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setUtenlandsopphold(String value) {
        this.utenlandsopphold = value;
    }

    public boolean isSetUtenlandsopphold() {
        return (this.utenlandsopphold!= null);
    }

    /**
     * Gets the value of the vurderingTilleggstekst property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getVurderingTilleggstekst() {
        return vurderingTilleggstekst;
    }

    /**
     * Sets the value of the vurderingTilleggstekst property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVurderingTilleggstekst(String value) {
        this.vurderingTilleggstekst = value;
    }

    public boolean isSetVurderingTilleggstekst() {
        return (this.vurderingTilleggstekst!= null);
    }

    /**
     * Gets the value of the opptakListe property.
     * 
     * @return
     *     possible object is
     *     {@link OpptakListe }
     *     
     */
    public OpptakListe getOpptakListe() {
        return opptakListe;
    }

    /**
     * Sets the value of the opptakListe property.
     * 
     * @param value
     *     allowed object is
     *     {@link OpptakListe }
     *     
     */
    public void setOpptakListe(OpptakListe value) {
        this.opptakListe = value;
    }

    public boolean isSetOpptakListe() {
        return (this.opptakListe!= null);
    }

    /**
     * Gets the value of the fagkode property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFagkode() {
        return fagkode;
    }

    /**
     * Sets the value of the fagkode property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFagkode(String value) {
        this.fagkode = value;
    }

    public boolean isSetFagkode() {
        return (this.fagkode!= null);
    }

    /**
     * Gets the value of the sprakListe property.
     * 
     * @return
     *     possible object is
     *     {@link SprakListe }
     *     
     */
    public SprakListe getSprakListe() {
        return sprakListe;
    }

    /**
     * Sets the value of the sprakListe property.
     * 
     * @param value
     *     allowed object is
     *     {@link SprakListe }
     *     
     */
    public void setSprakListe(SprakListe value) {
        this.sprakListe = value;
    }

    public boolean isSetSprakListe() {
        return (this.sprakListe!= null);
    }

    /**
     * Gets the value of the utdanningsplan property.
     * 
     * @return
     *     possible object is
     *     {@link Utdanningsplan }
     *     
     */
    public Utdanningsplan getUtdanningsplan() {
        return utdanningsplan;
    }

    /**
     * Sets the value of the utdanningsplan property.
     * 
     * @param value
     *     allowed object is
     *     {@link Utdanningsplan }
     *     
     */
    public void setUtdanningsplan(Utdanningsplan value) {
        this.utdanningsplan = value;
    }

    public boolean isSetUtdanningsplan() {
        return (this.utdanningsplan!= null);
    }

    /**
     * Gets the value of the planforslag property.
     * 
     * @return
     *     possible object is
     *     {@link Planforslag }
     *     
     */
    public Planforslag getPlanforslag() {
        return planforslag;
    }

    /**
     * Sets the value of the planforslag property.
     * 
     * @param value
     *     allowed object is
     *     {@link Planforslag }
     *     
     */
    public void setPlanforslag(Planforslag value) {
        this.planforslag = value;
    }

    public boolean isSetPlanforslag() {
        return (this.planforslag!= null);
    }

    /**
     * Gets the value of the terminSisteOpptak property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsYearSemester getTerminSisteOpptak() {
        return terminSisteOpptak;
    }

    /**
     * Sets the value of the terminSisteOpptak property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTerminSisteOpptak(FsYearSemester value) {
        this.terminSisteOpptak = value;
    }

    public boolean isSetTerminSisteOpptak() {
        return (this.terminSisteOpptak!= null);
    }

    /**
     * Gets the value of the any property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the any property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAny().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Object }
     * 
     * 
     */
    public List<Object> getAny() {
        if (any == null) {
            any = new ArrayList<Object>();
        }
        return this.any;
    }

    public boolean isSetAny() {
        return ((this.any!= null)&&(!this.any.isEmpty()));
    }

    public void unsetAny() {
        this.any = null;
    }

}
