
package no.usit.fsws.schemas.studinfo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import no.uis.fsws.studinfo.data.Extensible;
import no.uis.fsws.studinfo.data.FsTerminkodeYearMonth;
import no.uis.fsws.studinfo.data.FsTime;
import no.uis.fsws.studinfo.util.CalendarNorwegianAdapter;
import no.uis.fsws.studinfo.util.FsTerminkodeYMAdapter;
import no.uis.fsws.studinfo.util.FsTimeAdapter;


/**
 * <p>Java class for Vurdenhet complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="Vurdenhet">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="tid" type="{http://fsws.usit.no/schemas/studinfo}FsTerminkodeYearMonth"/>
 *         &lt;element name="tid-reell" type="{http://fsws.usit.no/schemas/studinfo}FsTerminkodeYearMonth"/>
 *         &lt;element name="vurdstatus" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="dato-eksamen" type="{http://fsws.usit.no/schemas/studinfo}FsDate"/>
 *         &lt;element name="klokkeslett-eksamen-fremmotetid" type="{http://fsws.usit.no/schemas/studinfo}FsTime"/>
 *         &lt;element name="dato-uttak" type="{http://fsws.usit.no/schemas/studinfo}FsDate"/>
 *         &lt;element name="klokkeslett-uttak" type="{http://fsws.usit.no/schemas/studinfo}FsTime"/>
 *         &lt;element name="dato-innlevering" type="{http://fsws.usit.no/schemas/studinfo}FsDate"/>
 *         &lt;element name="klokkeslett-innlevering" type="{http://fsws.usit.no/schemas/studinfo}FsTime"/>
 *         &lt;any maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Vurdenhet", propOrder = {
    "tid",
    "tidReell",
    "vurdstatus",
    "datoEksamen",
    "klokkeslettEksamenFremmotetid",
    "datoUttak",
    "klokkeslettUttak",
    "datoInnlevering",
    "klokkeslettInnlevering",
    "any"
})
public class Vurdenhet
    extends Extensible
    implements Serializable
{

    private final static long serialVersionUID = 1L;
    @XmlElement(required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsTerminkodeYMAdapter.class)
    protected FsTerminkodeYearMonth tid;
    @XmlElement(name = "tid-reell", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsTerminkodeYMAdapter.class)
    protected FsTerminkodeYearMonth tidReell;
    @XmlElement(required = true, nillable = true)
    protected String vurdstatus;
    @XmlElement(name = "dato-eksamen", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(CalendarNorwegianAdapter.class)
    protected Calendar datoEksamen;
    @XmlElement(name = "klokkeslett-eksamen-fremmotetid", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsTimeAdapter.class)
    protected FsTime klokkeslettEksamenFremmotetid;
    @XmlElement(name = "dato-uttak", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(CalendarNorwegianAdapter.class)
    protected Calendar datoUttak;
    @XmlElement(name = "klokkeslett-uttak", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsTimeAdapter.class)
    protected FsTime klokkeslettUttak;
    @XmlElement(name = "dato-innlevering", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(CalendarNorwegianAdapter.class)
    protected Calendar datoInnlevering;
    @XmlElement(name = "klokkeslett-innlevering", required = true, type = String.class, nillable = true)
    @XmlJavaTypeAdapter(FsTimeAdapter.class)
    protected FsTime klokkeslettInnlevering;
    @XmlAnyElement(lax = true)
    protected List<Object> any;

    /**
     * Gets the value of the tid property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsTerminkodeYearMonth getTid() {
        return tid;
    }

    /**
     * Sets the value of the tid property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTid(FsTerminkodeYearMonth value) {
        this.tid = value;
    }

    public boolean isSetTid() {
        return (this.tid!= null);
    }

    /**
     * Gets the value of the tidReell property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsTerminkodeYearMonth getTidReell() {
        return tidReell;
    }

    /**
     * Sets the value of the tidReell property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTidReell(FsTerminkodeYearMonth value) {
        this.tidReell = value;
    }

    public boolean isSetTidReell() {
        return (this.tidReell!= null);
    }

    /**
     * Gets the value of the vurdstatus property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getVurdstatus() {
        return vurdstatus;
    }

    /**
     * Sets the value of the vurdstatus property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVurdstatus(String value) {
        this.vurdstatus = value;
    }

    public boolean isSetVurdstatus() {
        return (this.vurdstatus!= null);
    }

    /**
     * Gets the value of the datoEksamen property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public Calendar getDatoEksamen() {
        return datoEksamen;
    }

    /**
     * Sets the value of the datoEksamen property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDatoEksamen(Calendar value) {
        this.datoEksamen = value;
    }

    public boolean isSetDatoEksamen() {
        return (this.datoEksamen!= null);
    }

    /**
     * Gets the value of the klokkeslettEksamenFremmotetid property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsTime getKlokkeslettEksamenFremmotetid() {
        return klokkeslettEksamenFremmotetid;
    }

    /**
     * Sets the value of the klokkeslettEksamenFremmotetid property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKlokkeslettEksamenFremmotetid(FsTime value) {
        this.klokkeslettEksamenFremmotetid = value;
    }

    public boolean isSetKlokkeslettEksamenFremmotetid() {
        return (this.klokkeslettEksamenFremmotetid!= null);
    }

    /**
     * Gets the value of the datoUttak property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public Calendar getDatoUttak() {
        return datoUttak;
    }

    /**
     * Sets the value of the datoUttak property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDatoUttak(Calendar value) {
        this.datoUttak = value;
    }

    public boolean isSetDatoUttak() {
        return (this.datoUttak!= null);
    }

    /**
     * Gets the value of the klokkeslettUttak property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsTime getKlokkeslettUttak() {
        return klokkeslettUttak;
    }

    /**
     * Sets the value of the klokkeslettUttak property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKlokkeslettUttak(FsTime value) {
        this.klokkeslettUttak = value;
    }

    public boolean isSetKlokkeslettUttak() {
        return (this.klokkeslettUttak!= null);
    }

    /**
     * Gets the value of the datoInnlevering property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public Calendar getDatoInnlevering() {
        return datoInnlevering;
    }

    /**
     * Sets the value of the datoInnlevering property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDatoInnlevering(Calendar value) {
        this.datoInnlevering = value;
    }

    public boolean isSetDatoInnlevering() {
        return (this.datoInnlevering!= null);
    }

    /**
     * Gets the value of the klokkeslettInnlevering property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public FsTime getKlokkeslettInnlevering() {
        return klokkeslettInnlevering;
    }

    /**
     * Sets the value of the klokkeslettInnlevering property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setKlokkeslettInnlevering(FsTime value) {
        this.klokkeslettInnlevering = value;
    }

    public boolean isSetKlokkeslettInnlevering() {
        return (this.klokkeslettInnlevering!= null);
    }

    /**
     * Gets the value of the any property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the any property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAny().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Object }
     * 
     * 
     */
    public List<Object> getAny() {
        if (any == null) {
            any = new ArrayList<Object>();
        }
        return this.any;
    }

    public boolean isSetAny() {
        return ((this.any!= null)&&(!this.any.isEmpty()));
    }

    public void unsetAny() {
        this.any = null;
    }

}
